# 贡献者指南

## Issues 管理

- 清晰的 Issue 标题和描述：确保每个 Issue 都有一个简洁明了的标题和详细的描述，以便其他贡献者理解问题的本质。
- 使用标签：为每个 Issue 添加适当的标签，以便分类和过滤问题，例如 bug、feature、documentation 等。
- 分配问题：将问题分配给相关的负责人，以确保问题得到适时处理。

## 代码提交

- 提交信息：每次代码提交应该附带有描述性的提交信息，解释了你所做的更改以及为何做出这些更改。
- 小而频繁的提交：尽量保持代码提交的规模小而频繁，以便更容易进行审查和集成。
- 遵循代码风格：遵循项目的代码风格指南，以确保代码风格的一致性。

## 分支管理

- 主分支保护：项目应该保护主分支（main）以防止直接推送，只能通过 PR 进行更改。
- 分支命名规范：定义分支命名规范，例如使用特性分支（feature branches）来开发新功能，使用修复分支（fix branches）来解决 bug。

## Release 发布

- 版本号管理：使用语义化版本号（Semantic Versioning）或其他合适的版本管理方式来标识发布的版本。
- 发布说明：为每个发布编写清晰的发布说明，包括新增功能、修复的 bug、已知问题等信息。

## Pull Request 提交

- PR 标题和描述：编写有意义的 PR 标题和描述，解释你的更改和目的。
- 关联 Issue：如果你的 PR 关联到某个 Issue，确保在描述中引用它，以便自动关联 Issue 和 PR。
- 针对目标分支：确保你的 PR 是基于正确的目标分支创建的，并解决了相关问题。
- 通过自动构建和测试：在提交 PR 之前，确保代码通过了项目的自动构建和测试流程。